#!/usr/bin/env python
# -*- coding: utf-8 -*-
from SimpleXMLRPCServer import SimpleXMLRPCServer
from SimpleXMLRPCServer import SimpleXMLRPCRequestHandler
import serial

#  INIT
sFrGiga = '0' #Переменная для гигагерц
sFrMega = '000' #Переменная для мегагерц
sFrKilo = '000' #Переменная для килогерц
sFrHz='000' #Переменная для герц
sModulation = '02' #Переменная для типа модуляции, стандартное значение 02 - амплитудная модудляция  
sFilter = '03' #Ширина фильтра, стандартное значение 03 - 50 КГц
sVolume = '50' # Громкость, стандартное значение 50 (максиальное 255)
sPower='00' #Питание
sSquelch = '00' #Щумоподавитель, по умолчанию выключен
sIfshift = '00' #Сдвиг промежуточной частоты
sAgc = '00' # AGC выключен
sAt = '00' # аттенюатор выключен
sNb = '00' # Антишумовой фильтр выключен

#Создаем объект для работы с последовательным портом
#У меня PCR1000 подключен через USB-RS323 переходник, поэтому я использую устройство /dev/ttyUSB0
#К слову под Linux мне не удалось заставить стабильно работать PCR1000 через RS-232, приемник выключался
# по неактивности через 15 секунд. При работе через переходник - все отлично.
# Забавно то, что под FreeBSD приемник стабильно работал и через RS-232 и через USB переходник.

ser = serial.Serial("/dev/ttyUSB0")
#ser = serial.Serial("/dev/ttyS0")

#Функции производящие передачу настроек в PCR1000
def set_pcr_frequency(): #Функция для задания частоты
	conf_string = 'K0'+ sFrGiga + sFrMega + sFrKilo + sFrHz + sModulation + sFilter + '00' #Конструируем строку для передачи
	print conf_string #Выведем строку в консоль, для того чтобы видеть что мы отсылаем.
	ser.write(conf_string + '\r\n') #Пишем в последовательный порт

def set_pcr_volume(): #Функция для задания громкости
	conf_string = 'J40'+ sVolume
	print conf_string
	ser.write(conf_string + '\r\n')

def set_pcr_squelch(): #Функция для управления шумоподавителем
	conf_string = 'J41'+ sSquelch
	print conf_string
	ser.write(conf_string + '\r\n')

def set_pcr_ifshift(): #Функция для контроля сдвигом частоты
	conf_string = 'J43'+ sIfshift
	print conf_string
	ser.write(conf_string + '\r\n')

def set_pcr_agc(): #Функция контроля AGC
	conf_string = 'J45'+ sAgc
	print conf_string
	ser.write(conf_string + '\r\n')

def set_pcr_nb():#Управление антишумовым фильтром
	conf_string = 'J46'+ sNb
	print conf_string
	ser.write(conf_string + '\r\n')

def set_pcr_at():#Управление аттенютенатором
	conf_string = 'J46'+ sAt
	print conf_string
	ser.write(conf_string + '\r\n')

def set_pcr_power():#Функция управления питанием
	conf_string = 'H1'+ sPower
	print conf_string
	ser.write(conf_string + '\r\n')	#Пишем в порт
	reply = ser.readline() #Считываем ответ из порта
	print reply #выводим ответ в консоль

#-----------Основнная программа------------------------
#Открываем последовательный порт
if ser.isOpen(): # Если он уже открыт 
	ser.close() # Закроем
	ser.open() # Откроем вновь
	ser.write("test\n") # Запишем что-нибудь
else: # Если закрыт
	ser.open()  # Откроем порт
	ser.write("test\n") # Пишем что-нибудь
reply = ser.readline(2) # Читаем ответ
print reply # Выводим ответ
ser.write("G300\r\n") # Переводим приемник в режим простого приема команд. В этом режиме PCR1000 не будет немедленно отвечать, была ли
#принята команда, или она была отвергнута из-за ошибки. 

class RequestHandler(SimpleXMLRPCRequestHandler):
	    rpc_paths = ('/RPC2',)
# Создаем наш XMLRPC сервер, и настраиваем его работать на localhost, на порту 8088
server = SimpleXMLRPCServer(("localhost", 8088),
		requestHandler=RequestHandler,
		logRequests = False,
		 allow_none=True)
server.register_introspection_functions()

#Начинаем определять наши callback функции которые будут вызываться клиентом
class ControlFunctions:
	def set_fr_mhz(self, x): #Эта функция будет вызвана как только будет измененно значение мегагерц
		global sFrMega # Используем нашу глобальную переменную sFrMega
		sFrMega = "%03d" % (x) # Присваиваем переменной sFrMega пришедшее значение, используем десятичный формат 
		set_pcr_frequency() # Вызваем нашу функцию установки частоты
	def set_fr_khz(self, x):
		global sFrKilo
		sFrKilo = "%03d" % (x)
		set_pcr_frequency()
	def set_fr_modulation(self, x):
		global sModulation
		sModulation = "%02d" % (x)
		set_pcr_frequency()
	def set_fr_filter(self, x):
		global sFilter
		sFilter = "%02d" % (x)
		set_pcr_frequency()
	def set_volume(self, x):
		global sVolume
		sVolume = "%02X" % (x) #Обратите внимание что тут мы используем шестнадцатиричный формат
		set_pcr_volume()
	def set_squelch(self, x):
		global sSquelch
		sSquelch = "%02X" % (x)
		set_pcr_squelch()
	def set_ifshift(self, x):
		global sIfshift
		sIfshift = "%02X" % (x)
		set_pcr_ifshift()
	def set_agc(self, x):
		global sAgc
		sAgc = "%02d" % (x)
		set_pcr_agc()
	def set_nb(self, x):
		global sNb
		sNb = "%02d" % (x)
		set_pcr_nb()
	def set_at(self, x):
		global sAt
		sAt = "%02d" % (x)
		set_pcr_at()
	def set_power(self, x):
		global sPower
		sPower = "%02d" % (x)
		set_pcr_power()
server.register_instance(ControlFunctions()) #регистрируем наши callback функции
server.serve_forever() # Запускаем наш сервер

